#!/usr/bin/env python
# -*- coding: utf-8 -*-

from PyQt4.QtCore import *
from PyQt4.QtGui import *

from defineThread import *
from defineEvent import *

import glob
import sys,os

class advanceSearchNet(QDialog):
	
	def __init__(self,*args):
		apply(QDialog.__init__,(self,))
		self.engine=args[1]
		self.artist=args[2]
		self.title=args[3]
		self.locale=args[4]
		self.proxy=args[5]
		self.row=0
		self.currentUrlList=[]
		self.setWindowTitle(_('Search lrc on internet (advance)'))
		MainWindowLayout=QVBoxLayout(None)
		
		layout1=QHBoxLayout(None)
		layout1.setContentsMargins(0,0,0,5)
		self.engineLabel=QLabel(_('Search engines :'),self)
		self.engineList=QComboBox(self)
		engineList=QStringList()
		for i in glob.glob('./engines/engine_*.py'):
			i=os.path.basename(i)[7:-3]
			engineList.append(i)
		self.engineList.addItems(engineList)
		self.engineList.setCurrentIndex(engineList.indexOf(self.engine))
		layout1.addWidget(self.engineLabel)
		layout1.addWidget(self.engineList)
		
		layout2=QVBoxLayout(None)
		layout2.setContentsMargins(0,0,0,5)
		layout21=QHBoxLayout(None)
		self.artistLabel=QLabel(_('Artist'),self)
		self.artistBox=QLineEdit(unicode(self.artist,self.locale),self)# remember to transfer to unicode
		layout21.addWidget(self.artistLabel)
		layout21.addWidget(self.artistBox)
		layout22=QHBoxLayout(None)
		self.titleLabel=QLabel(_('Title'),self)
		self.titleBox=QLineEdit(unicode(self.title,self.locale),self)# remember to transfer to unicode
		layout22.addWidget(self.titleLabel)
		layout22.addWidget(self.titleBox)
		layout2.addLayout(layout21)
		layout2.addLayout(layout22)
		
		layout3=QHBoxLayout(None)
		layout3.setContentsMargins(0,0,0,5)
		self.searchButton=QPushButton(_('Search'),self)
		self.testButton=QPushButton(_('Test'),self)
		self.testButton.setEnabled(False)
		self.returnButton=QPushButton(_('Back'),self)
		self.returnButton.setEnabled(False)
		self.clearButton=QPushButton(_('Clear'),self)
		self.clearButton.setEnabled(False)
		layout3.addWidget(self.searchButton)
		layout3.addWidget(self.testButton)
		layout3.addWidget(self.returnButton)
		layout3.addWidget(self.clearButton)
		
		self.table=QTableWidget(0,3,self)
		self.table.setMinimumWidth(300)
		self.table.setEditTriggers(QAbstractItemView.NoEditTriggers)
		self.table.setSelectionBehavior(QAbstractItemView.SelectRows)
		self.table.setSelectionMode(QAbstractItemView.SingleSelection)
		headerName=QStringList()<<_('Artist')<<_('Title')<<_('Search engines')
		self.table.setHorizontalHeaderLabels(headerName)
		
		layout4=QVBoxLayout(None)
		layout4.setContentsMargins(0,0,0,5)
		self.download=QCheckBox(_('Download the selected lrc'),self)
		self.download.setEnabled(False)
		#self.inDatabase=QCheckBox(u'在数据库文件中记录该结果',self)
		#self.inDatabase.setEnabled(False)
		layout4.addWidget(self.download)
		#layout4.addWidget(self.inDatabase)
		
		layout5=QHBoxLayout(None)
		layout5.setSpacing(20)
		layout5.addStretch(0)
		layout5.setContentsMargins(0,20,0,5)
		self.okButton=QPushButton(_('Ok'),self)
		self.okButton.setEnabled(False)
		self.cancelButton=QPushButton(_('Cancel'),self)
		layout5.addWidget(self.okButton)
		layout5.addWidget(self.cancelButton)
		
		MainWindowLayout.addLayout(layout1)
		MainWindowLayout.addLayout(layout2)
		MainWindowLayout.addLayout(layout3)
		MainWindowLayout.addWidget(self.table)
		MainWindowLayout.addLayout(layout4)
		MainWindowLayout.addLayout(layout5)
		self.setLayout(MainWindowLayout)
		
		self.connect(self.okButton,SIGNAL("clicked()"),self,SLOT("accept()"))
		self.connect(self.cancelButton,SIGNAL("clicked()"),self,SLOT("reject()"))
		self.connect(self.searchButton,SIGNAL("clicked()"),self.searchAction)
		self.connect(self.clearButton,SIGNAL("clicked()"),self.clearAction)
		self.connect(self.engineList,SIGNAL("activated(QString)"),self.changeEngine)
		self.connect(self.table,SIGNAL("cellClicked(int,int)"),self.selectItem)
		self.connect(self.testButton,SIGNAL("clicked()"),self.enableReturnButton)
		self.connect(self.returnButton,SIGNAL("clicked()"),self.disableReturnButton)
		#self.connect(self.download,SIGNAL("toggled(bool)"),self.enableRecord)
	
	def customEvent(self,ev):
		if(ev.type()==QEvent.User+5):
			lrcList=ev.alist
			engineReturn=ev.engine
			for i in range(len(lrcList)):
				self.currentUrlList.append([lrcList[i][2],engineReturn])
				self.row+=1
				self.table.setRowCount(self.row)
				for j in range(2):
					self.table.setItem(self.row-1,j,QTableWidgetItem(lrcList[i][j].decode('utf8'),0))
				self.table.setItem(self.row-1,2,QTableWidgetItem(engineReturn,0))
			self.clearButton.setEnabled(True)
		self.searchButton.setEnabled(True)
	
	def enableReturnButton(self):
		self.returnButton.setEnabled(True)
	
	def disableReturnButton(self):
		self.returnButton.setEnabled(False)
	
	def clearAction(self):
		self.currentUrlList=[]
		self.row=0
		self.table.setRowCount(0)
		self.clearButton.setEnabled(False)
		self.okButton.setEnabled(False)
		self.testButton.setEnabled(False)
		self.download.setChecked(False)
		self.download.setEnabled(False)
		self.returnButton.setEnabled(False)
		#self.inDatabase.setChecked(False)
		#self.inDatabase.setEnabled(False)
	
	def selectItem(self,row,col):
		self.okButton.setEnabled(True)
		self.testButton.setEnabled(True)
		self.download.setEnabled(True)
		self.currentRow=row
	
	def changeEngine(self,e):
		self.engine=str(e)
	
	def searchAction(self):
		self.artist=unicode(self.artistBox.text()).encode(self.locale)
		self.title=unicode(self.titleBox.text()).encode(self.locale)
		self.searchButton.setEnabled(False)
		self.downloadThread=netThread(self,self.artist,self.title,self.locale,self.proxy,self.engine,False)
		self.downloadThread.start()

def main(args):
	app=QApplication(args)
	win=advanceSearchNet('d','ttPlayer','苏打绿','是我的海','utf8',None)
	win.show()
	sys.exit(app.exec_())

#def _(x):
	#return x
	
if(__name__=="__main__"):
	main(sys.argv)