#!/usr/bin/env python
# -*- coding: utf-8 -*-

from PyQt4.QtCore import QThread
from PyQt4.QtGui import QApplication
from engines import *
from defineEvent import *
from mpris import playerBase
import dbus
from dbus.mainloop.glib import DBusGMainLoop
import gobject

class netThread(QThread):
	
	'''
	This class provide a network function for lrcShow-II, normally it connect to the search engine and analysis if the lrc we needed exists
	'''
	
	def __init__(self,receiver,artist,title,locale,proxy,engine,t=True):
		QThread.__init__(self)
		self.receiver=receiver
		self.artist=artist
		self.title=title
		self.locale=locale
		self.proxy=proxy
		self.engine=engine
		self.t=t
	
	def run(self):
		exec 'p=%s.%s(self.proxy,self.locale)' %(self.engine,self.engine)
		
		originalLrc,timeOut=p.request(self.artist,self.title)
			
		if(originalLrc is None):
			self.sleep(1)
			ev=netEvent(None,timeOut,p.netEncoder)
			QApplication.postEvent(self.receiver,ev)
		else:
			if(self.t):
				if(len(originalLrc)==1):
					originalLrc,timeOut=p.downIt(originalLrc[0][2])
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,p.netEncoder)
					QApplication.postEvent(self.receiver,ev)
				else:
					self.sleep(1)
					ev=userChooseEvent(originalLrc,self.engine)
					QApplication.postEvent(self.receiver,ev)
			else:
				ev=advanceUserChooseEvent(originalLrc,self.engine)
				QApplication.postEvent(self.receiver,ev)

class downAfterChoose(QThread):# modular engine design needed
	
	def __init__(self,receiver,url,proxy,engine,fromAdvDown=False):
		QThread.__init__(self)
		self.receiver=receiver
		self.url=url
		self.proxy=proxy
		self.engine=engine
		self.fromAdvDown=fromAdvDown
	
	def run(self):
		exec 'p=%s.%s(self.proxy)' %(self.engine,self.engine)

		originalLrc,timeOut=p.downIt(self.url)
		ev=netEvent(originalLrc,timeOut,p.netEncoder,self.fromAdvDown)
		QApplication.postEvent(self.receiver,ev)
		

class myThread(QThread):
	
	'''
	This thread class provides the function to waiting for Amarok's signal, and when lrcShow-II first run, it would to decide the Amarok's status
	'''
	
	def __init__(self,receiver,player):
		QThread.__init__(self)
		#self.app=app
		self.receiver=receiver
		self.player=player
	
	####### for quodlibet or qmmp ############
	
	def songStarted(self,*arg):
		print 'songStarted'
		amarokSignal='engineStateChange'
		amarokStatus='playing'
		self.sleep(1)#for a xine engine's bug
		ev=myEvent(amarokSignal,amarokStatus)
		QApplication.postEvent(self.receiver,ev)
	
	def songEnded(self,*arg):
		print 'songEnded'
		amarokSignal='engineStateChange'
		amarokStatus='stop'
		ev=myEvent(amarokSignal,amarokStatus)
		QApplication.postEvent(self.receiver,ev)
	
	def paused(self,*arg):
		print 'paused'
		amarokSignal='engineStateChange'
		amarokStatus='pause'
		ev=myEvent(amarokSignal,amarokStatus)
		QApplication.postEvent(self.receiver,ev)
	
	def unPaused(self,*arg):
		print 'unPaused'
		amarokSignal='engineStateChange'
		amarokStatus='playing'
		self.sleep(1)#for a xine engine's bug
		ev=myEvent(amarokSignal,amarokStatus)
		QApplication.postEvent(self.receiver,ev)
	
	###### end ######################
	
	def trackChanged(self,arg):
		#pass
		print 'trackChanged'
		#amarokSignal='engineStateChange'
		#amarokStatus='playing'
		#self.sleep(1)#for a xine engine's bug
		#ev=myEvent(amarokSignal,amarokStatus)
		#QApplication.postEvent(self.receiver,ev)
	
	def statusChanged(self,arg):
		print 'statusChanged'
		if(self.player=='amarok' or self.player=='vlc'):
			arg=arg[0]
		print arg
		if(arg==2):
			amarokSignal='engineStateChange'
			amarokStatus='stop'
			ev=myEvent(amarokSignal,amarokStatus)
			QApplication.postEvent(self.receiver,ev)
		elif(arg==1):
			amarokSignal='engineStateChange'
			amarokStatus='pause'
			ev=myEvent(amarokSignal,amarokStatus)
			QApplication.postEvent(self.receiver,ev)
		elif(arg==0):
			amarokSignal='engineStateChange'
			amarokStatus='playing'
			self.sleep(1)#for a xine engine's bug
			ev=myEvent(amarokSignal,amarokStatus)
			QApplication.postEvent(self.receiver,ev)
	
	def initStatus(self,arg):
		if(self.player=='amarok' or self.player=='vlc'):
			arg=arg[0]
		if(self.player=='quodlibet'):
			if(arg==True):
				arg=0
			else:
				arg=1
		if(arg==0 or arg=='playing'):#playing
			amarokStatus='playing'
		elif(arg==2 or arg=='stoped'):#stop
			amarokStatus='stop'
		else:#pause
			amarokStatus='pause'
		amarokSignal='startup'
		ev=myEvent(amarokSignal,amarokStatus)
		QApplication.postEvent(self.receiver,ev)

	def run(self):
		k=playerBase.playerBase(self.player)
		DBusGMainLoop(set_as_default=True)                         
		bus = dbus.SessionBus()
		proxy_obj = bus.get_object(k.obj1,k.obj2)
		iface = dbus.Interface(proxy_obj, k.obj3)
		if(self.player=='exaile'):
			self.initStatus(iface.status())
			iface.connect_to_signal("playingUriChanged", self.trackChanged)
			iface.connect_to_signal("state_changed", self.statusChanged)
		elif(self.player=='quodlibet'):
			self.initStatus(bool(iface.IsPlaying()))
			iface.connect_to_signal("SongStarted", self.songStarted)
			iface.connect_to_signal("SongEnded", self.songEnded)
			iface.connect_to_signal("Paused", self.paused)
			iface.connect_to_signal("Unpaused", self.unPaused)
		elif(self.player=='qmmp'):
			ifaceProperties=dbus.Interface(proxy_obj, 'org.freedesktop.DBus.Properties')
			if(bool(ifaceProperties.Get('org.qmmp.dbus','isPaused'))):
				k=1
			elif(bool(ifaceProperties.Get('org.qmmp.dbus','isStopped'))):
				k=2
			else:
				k=0
			self.initStatus(k)
			iface.connect_to_signal('started',self.songStarted)
			iface.connect_to_signal('paused',self.paused)
			iface.connect_to_signal('stopped',self.songEnded)
		else:
			self.initStatus(iface.GetStatus())
			iface.connect_to_signal("TrackChange", self.trackChanged)
			iface.connect_to_signal("StatusChange", self.statusChanged)
		mainloop = gobject.MainLoop()