#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: engine.py

import urllib,re,os

class engine:
	
	def __init__(self,proxy=None,locale="utf-8",check=True):
		self.locale=locale
		self.proxy=proxy
		self.netEncoder=None
		self.needCheck=check
	
	def request(self,artist,title):
		raise NotImplementedError('request must be implemented in subclass')
		
	def downIt(self,url):
		#print(url)
		try:
			ff=urllib.urlopen(url,None,self.proxy)
			originalLrc=ff.read()
			ff.close()
		except IOError:
			return (None,True)
		else:
			if(self.needCheck):
				if(self.netEncoder == None or self.netEncoder.startswith("utf-16") or self.netEncoder.startswith("utf-32")):
					if not self.validLrc(originalLrc):
						originalLrc = None
				elif(not re.search('\[\d{1,}:\d{1,}.*?\]',originalLrc)):
					originalLrc=None
			return (originalLrc,False)

	def orderResults(self,results,artist,title):
		comp=[artist,title,'']
		temp=[]
		for i in results:
			temp.append([self.cmpResult(comp,i),i])
		temp.sort()
		temp.reverse()
		results=[]
		for i in temp:
			results.append(i[1])
		return results
		
	def cmpResult(self,result,comp):
		value=self.similarity(result[0],comp[0])#artist
		value+=self.similarity(result[1],comp[1])#title
		value=value/2
		return value
	
	def similarity(self,string1,string2):
		if string1.lower() == string2.lower():
			return 1
		string1=self.tokenize(string1.lower())
		string2=self.tokenize(string2.lower())
		count=0
		for i in string1:
			if i in string2:
				count+=1
		return count/len(string1)

	def tokenize(self,string):
		string=string.replace('(',' ').replace(')',' ')
		string=string.replace('[',' ').replace(']',' ')
		string=string.replace('[',' ').replace(']',' ')
		ignore=['a','an','the']
		string=string.split()
		for token in string:
			if token.lower() in ignore:
				string.remove(token)
		return string
	
	def validLrc(self,lrc):
		partial=""
		for i in lrc:
			if(ord(i) < 128 and ord(i) != 0):
				partial+=i
		if(re.search('\[\d{1,}:\d{1,}.*?\]',partial)):
			return True
		else:
			return False

