#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: evillyrics.py
#
# Some of this code is taken from the Googlyrics2 amarokscript.
# So, if you like this script, we suggest you to give a try to
# the original script at http://quicode.com/googlyircs2 (GPLv3)
#
# The conversion from Kas file to lrc is based upon the python's difflib
# 

import engine,urllib,re
import urllib2,cookielib
from htmlentitydefs import name2codepoint as n2cp
import sys,difflib

def substitute_entity(match):
	ent = match.group(2)
	if match.group(1) == "#":
		return unichr(int(ent))
	else:
		cp = n2cp.get(ent)
		if cp:
			return unichr(cp)
		else:
			return match.group()

def decode_htmlentities(string):
	entity_re = re.compile("&(#?)(\d{1,5}|\w{1,8});")
	return entity_re.subn(substitute_entity, string)[0]

urlcheck = {}
urlcheck['6lyrics']			= re.compile(r'6lyrics\.com')
urlcheck['actionext']		= re.compile(r'actionext\.com')
urlcheck['allthelyrics']	= re.compile(r'allthelyrics\.com')
urlcheck['asklyrics']		= re.compile(r'asklyrics\.com')
urlcheck['azlyrics']		= re.compile(r'azlyrics\.com')
#urlcheck['elyrics']			= re.compile(r'elyrics\.net')  #removed cause text is bad formatted
urlcheck['freelyrics']		= re.compile(r'free-lyrics\.net')
urlcheck['hotlyrics']		= re.compile(r'hotlyrics\.net')
urlcheck['justsomelyrics']	= re.compile(r'justsomelyrics\.com')
urlcheck['kohit']			= re.compile(r'kohit\.net')
urlcheck['kovach']			= re.compile(r'kovach.co.yu')
urlcheck['kovideo']			= re.compile(r'kovideo\.net/lyrics')
urlcheck['leoslyrics']		= re.compile(r'leoslyrics\.com')
urlcheck['letras']			= re.compile(r'letras.terra.com.br')
urlcheck['letssingit']		= re.compile(r'letssingit\.com')
urlcheck['lyrics007']		= re.compile(r'lyrics007\.com')
urlcheck['lyricsbay']		= re.compile(r'lyricsbay\.com')
urlcheck['lyricsbox']		= re.compile(r'lyricsbox\.com')
urlcheck['lyricsdepot']		= re.compile(r'lyricsdepot\.com')
urlcheck['lyricsdir']		= re.compile(r'lyricsdir\.com')
urlcheck['lyricsdomain']	= re.compile(r'lyricsdomain\.com')
urlcheck['lyricsdownload']	= re.compile(r'lyricsdownload\.com')
urlcheck['lyricsee']		= re.compile(r'lyrics\.ee')
urlcheck['lyricsfreak']		= re.compile(r'lyricsfreak\.com')
urlcheck['lyrics-keeper']	= re.compile(r'lyrics-keeper\.com')
urlcheck['lyricsmania']		= re.compile(r'lyricsmania.com')
urlcheck['lyricsmode']		= re.compile(r'lyricsmode\.com')
urlcheck['lyricsondemand']	= re.compile(r'lyricsondemand\.com')
urlcheck['lyricspy']		= re.compile(r'lyricspy\.com')
urlcheck['lyricsspot']		= re.compile(r'lyricsspot.com')
urlcheck['lyricstime']		= re.compile(r'lyricstime.com')
urlcheck['lyricwiki']		= re.compile(r'lyricwiki.org')
urlcheck['lyriki']			= re.compile(r'lyriki.com')
urlcheck['madmusicarchive']	= re.compile(r'themadmusicarchive\.com')
urlcheck['megalyrics']		= re.compile(r'megalyrics.ru')
urlcheck['metrolyrics']		= re.compile(r'metrolyrics\.com')
urlcheck['mldb']			= re.compile(r'mldb\.org')
urlcheck['mp3bg']			= re.compile(r'mp3-bg.com')
urlcheck['mp3-download']	= re.compile(r'mp3-download-lyrics\.com')
urlcheck['mp3lyrics']		= re.compile(r'mp3lyrics\.org')
urlcheck['musicsonglyrics']	= re.compile(r'musicsonglyrics\.com')
urlcheck['mylyricsbox']		= re.compile(r'mylyricsbox.com')
urlcheck['plyrics']			= re.compile(r'plyrics\.com')
urlcheck['rare-lyrics']		= re.compile(r'rare-lyrics\.com')
urlcheck['rockpoplyrics']	= re.compile(r'rockpoplyrics\.com')
urlcheck['sing365']			= re.compile(r'sing365\.com')
urlcheck['song-lyrics']		= re.compile(r'song-lyrics\.net')
urlcheck['songmeanings']	= re.compile(r'songmeanings.net')
urlcheck['stlyrics']		= re.compile(r'stlyrics\.com')
urlcheck['sweetslyrics']	= re.compile(r'sweetslyrics\.com')
urlcheck['wearethelyrics']	= re.compile(r'wearethelyrics.com')

sites = {}
sites['6lyrics']			=  re.compile(r'<span id="slly">(.*?)</span>',re.DOTALL)
sites['actionext']			=  re.compile(r'<b>performed by .*?<\/b>(.*)<div class="foundat">', re.DOTALL)
sites['allthelyrics']		=  re.compile(r'small_trans_right.gif" width="16" height="17"/ align="middle">(.*?)<img ',re.DOTALL)
sites['asklyrics']			=  re.compile(r'<pre class="lc">(.*?)</pre>',re.DOTALL)
sites['azlyrics']			=  re.compile(r'<FONT size=2>.*?<BR>\s*(.*?)\[ <a href="http:\/\/www.azlyrics.com">www.azlyrics.com<\/a> \]<BR><BR>', re.DOTALL)
#sites['elyrics']			=  re.compile(r'<PRE style=font-family:verdana>(.*?)</PRE>',re.DOTALL)
sites['freelyrics']			=  re.compile(r'<td class="style5" style="font-weight:normal;padding-left:5px;">(.*?)</td>', re.DOTALL)
sites['hotlyrics']			=  re.compile(r'<!-- GOOGLE END //-->(.*?)<script type="text/javascript">', re.DOTALL)
sites['justsomelyrics']		=  re.compile(r'phone2.gif" alt="phone" />(.*?)<div class="adsdiv">', re.DOTALL)
sites['kohit']				=  re.compile(r'<p style="width:450px; font-size:11px;">(.*?)</p>',re.DOTALL)
sites['kovach']				=  re.compile(r'>Z</a>.*?<td width="100%" valign="top">(.*?)</td></tr></table>', re.DOTALL)
sites['kovideo']			=  re.compile(r'</div>\r\n<p>(.*?)<p style="text-align:center;">',re.DOTALL)
sites['leoslyrics']			=  re.compile(r'<font face="Trebuchet MS, Verdana, Arial" size=-1>(.*?)<\/font>', re.DOTALL)
sites['letras']				=  re.compile(r'<p id=\'cmp\'>.*?</p>(.*?)</p><br/>', re.DOTALL)
sites['letssingit']			=  re.compile(r'phone_right.gif" ALIGN="absmiddle" border=0 vspace=o hspace=0></A>(.*)<DIV align="center">', re.DOTALL)
sites['lyrics007']			=  re.compile(r'<br><br><div align=center>(.*?)<br><div align=center>', re.DOTALL)
sites['lyricsbay']			=  re.compile(r'&lt;/font&gt;<br>(.*?)<BR>',re.DOTALL)
sites['lyricsbox']			=  re.compile(r'<PRE style="font:12px arial">(.*?)</PRE>',re.DOTALL)
sites['lyricsdepot']		=  re.compile(r'</script>\r\n<br><br>(.*?)<img src="',re.DOTALL)
sites['lyricsdir']			=  re.compile(r'<div id="protected_lyrics">(.*?)<span class="copyright">',re.DOTALL)
sites['lyricsdownload']		=  re.compile(r'<center><font class="txt_1">(.*?)</font> </center>',re.DOTALL)
sites['lyricsdomain']		=  re.compile(r'<div id="cnt_bdy">(.*?)</div>',re.DOTALL)
sites['lyricsee']			=  re.compile(r'<img src="img/lyrics/icon_add.gif" alt="Lisa laul" border="0"></a></td></tr>.*?-->(.*?)<p><br>', re.DOTALL)
sites['lyricsfreak']		=  re.compile(r'<div style="float: right; clear: right;">(.*?)<blockquote>',re.DOTALL)
sites['lyrics-keeper']		=  re.compile(r'<div style="margin-top:10px"></div>(.*?)<div style="margin-top:30px"></div>',re.DOTALL)
sites['lyricsmania']		=  re.compile(r'small_trans_right.gif" border="0"></a>(.*?)<span style="font-size:14px;">', re.DOTALL)
sites['lyricsmode']			=  re.compile(r'<div id="songlyrics">(.*?)</div>',re.DOTALL)
sites['lyricsondemand']		=  re.compile(r'<font size="2" face="Verdana">(.*?)<p>',re.DOTALL)
sites['lyricspy']			=  re.compile(r'mobile2.gif" border="0" />(.*?)<div', re.DOTALL)
sites['lyricsspot']			=  re.compile(r'"Ringtones" border="no"><p><br><font size="2">(.*?)<img src="/images/phone-left.gif"', re.DOTALL)
sites['lyricstime']			=  re.compile(r'phone-right.gif" width="18" height="18" alt="Ringtones" border="no">\r\n</p>(.*?)</p>', re.DOTALL)
sites['lyricwiki']			=  re.compile(r'<div class=\'lyricbox\' >(.*?)</div', re.DOTALL)
sites['lyriki']				=  re.compile(r'<\/div>\n<p>(.*?)<\/p>', re.DOTALL)
sites['madmusicarchive']	=  re.compile(r'<td><span class="Verdana8">(.*?)<\/span>', re.DOTALL)
sites['megalyrics']			=  re.compile(r'http://pagead2.googlesyndication.com/pagead/show_ads.js">(.*?)<br><a href=\"javascript', re.DOTALL)
sites['metrolyrics']		=  re.compile(r'blue_small_trans_right.gif">(.*?)<img', re.DOTALL)
sites['mldb']				=  re.compile(r'<p class=songtext>(.*?)<\/table>', re.DOTALL)
sites['mp3bg']				=  re.compile(r'<\/h2><p>(.*?)<ul class="admin">', re.DOTALL)
sites['mp3-download']		=  re.compile(r'<Br>(.*?)<a href="',re.DOTALL)
sites['mp3lyrics']			=  re.compile(r'<span id=inclm></span>(.*?)</td>',re.DOTALL)
sites['musicsonglyrics']	=  re.compile(r'<tr><td class="style2"><p>(.*?)</p>',re.DOTALL)
sites['mylyricsbox']		=  re.compile(r'<div class="songLyrics">(.*?)<\/div>', re.DOTALL)
sites['plyrics']			=  re.compile(r'phone_flip.gif" alt="">\r\n</div>(.*?)<div class="pmedia">',re.DOTALL)
sites['rare-lyrics']		=  re.compile(r'<font size="2" face="Courier New, Courier, mono" color="#000000">(.*?)</font>',re.DOTALL)
sites['rockpoplyrics']		=  re.compile(r'<pre id=lyrics>(.*?)</pre>',re.DOTALL)
sites['sing365']			=  re.compile(r'phone2.gif border=0>(.*?)<DIV ALIGN=center>', re.IGNORECASE | re.DOTALL)
sites['song-yrics']			=  re.compile(r'</div></div><p class="smaller">(.*?)</p>',re.DOTALL)
sites['songmeanings']		=  re.compile(r'<td width="100%" style="text-align:left;">.*<td width="100%" style="text-align:left;">\s*(.*?)\s*<\/td>', re.DOTALL)
sites['stlyrics']			=  re.compile(r'<!--Song:[^>]+>(.*?)<!--Lyrics End-->',re.DOTALL)
sites['sweetslyrics']		=  re.compile(r'small_trans_right.gif" border="0" alt="" /></a><br /><br />(.*?)<div align="center">',re.DOTALL)
sites['wearethelyrics']		=  re.compile(r'<\/h3>\n<p>\s*(.*?)\s*<\/p>', re.DOTALL)

def ms2timestamp(ms):
	mins="0%s" % int(ms/1000/60)
	sec="0%s" % int((ms/1000)%60)
	msec="0%s" % int((ms%1000)/10)
	return "[%s:%s.%s]" % (mins[-2:],sec[-2:],msec[-2:])

def purgeText(txt):
	temp=txt.splitlines()
	txt=[]
	for i in range(len(temp)):
		if(re.search("[\w]{2,}",temp[i].strip())):
			txt.append(temp[i].strip())
	return txt

def purgeTextAndKas(testo,KAS):
	if type(testo) != type([]):
		testo=purgeText(testo)
	core=re.compile("^karaoke:").sub("",KAS.split(';')[0])
	#print "core",core
	tokens=[core[i:i+2] for i in range(len(core)) if i%4==2]
	kas=[i.lower() for i in tokens]
	#print "kas",kas
	times=[core[i:i+2] for i in range(len(core)) if i%4==0]
	#print "times",times
	times=[(((ord(token[0])-64)*64 + (ord(token[1])-64))*200) for token in times]
	#print "times",times

	tot=[]
	for i in range(len(kas)):
		tot.append([kas[i],times[i]])

	purge=lambda x: re.compile("[^\w]").sub("",x)
	txt=[purge(line)[:2].lower() for line in testo]
	#print "txt",txt

	d=difflib.ndiff(txt,kas)
	i=0
	j=0
	surplus=[]
	deficit=[]
	for line in d:
		if str(line)[0] == '+':
			surplus.append(i)
			i+=1
			continue
		elif str(line)[0] == '-':
			deficit.append(j)
			j+=1
			continue
		i+=1
		j+=1

	count=0
	for i in surplus:
		del tot[i-count]
		count+=1

	count=0
	for i in deficit:
		if(i-count > 0):
			testo[i-count-1]+=" "+testo[i-count]
		del testo[i-count]
		count+=1
	#print testo
	return "\r\n".join([ms2timestamp(tot[i][1])+testo[i] for i in range(len(tot))]).encode('utf-8')

def purgeString(s):
	s=re.compile("[ ]+").sub(" ",s.lower().strip()).split(' ')
	ignore_words="i;the;you;a;in;at;th;st;various;artist;track;unknown;kbps;vbr;mp3".split(';')
	for i in ignore_words:
		try:
			s.remove(i)
		except:
			pass
	return " ".join(s)

class evillyrics(engine.engine):
	
	def __init__(self,proxy,locale=None):
		engine.engine.__init__(self,proxy,locale)
		#self.netEncoder=None
		
	def request(self,artist,title):
		#url="http://www.evillabs.sk/evillyrics/getkaraoke.php?artist=%s&song=%s" % (urllib.quote_plus(artist),urllib.quote_plus(title))
		url="http://www.evillabs.sk/evillyrics/gc2.php?artist=%s&song=%s" % (urllib.quote_plus(artist),urllib.quote_plus(title))
		try:
			file=urllib.urlopen(url,None,self.proxy)
			kas=file.read()
			file.close()
		except IOError:
			return (None,True)
		else:
			if(kas == "error" or kas == None):
				return (None,False)
			try:
				if (not kas.split(';')[1].isdigit()):
					return (None,False)
			except:
				return (None,False)
			else:
				#print kas
				return ([[artist,title,[artist,title,kas]]],False)
	
	def downIt(self,url):
		artist=url[0]
		title=url[1]
		kas=url[2]
		if kas.split(";")[-1].lower().startswith("http://"):
			url = kas.split(";")[-1]
			for key in urlcheck:
				if urlcheck[key].search(url):
					lyrics = self.getLyrics(url,sites[key])
					if len(lyrics)>10:
						#return (kas2lrc(kas,lyrics),False)
						return (purgeTextAndKas(lyrics,kas),False)
		results,timeout = self.getFromGoogle(artist,title,True)
		if timeout:
			return (None,True)
		if not results:
			return (None,False)
		for address,regex in results:
			lyrics,timeout = self.getLyrics(address,regex)
			if timeout or lyrics==None:
				continue
			if len(lyrics)>10:
				#return (kas2lrc(kas,lyrics),False)
				#print lyrics
				result=purgeTextAndKas(lyrics,kas)
				#print result
				return (result,False)
		return (None,False)

	def getFromGoogle(self,artist,title,likeEvilLyrics=False):
		query=""
		if likeEvilLyrics:
			query="lyrics %s %s" % (purgeString(artist),purgeString(title))
		else:
			query="lyrics intitle:\"%s\" intitle:\"%s\"" % (artist,title)
		url="http://www.google.com/pda/search?mrestrict=xhtml&hl=en&lr=&num=5&q=%s" % (urllib.quote_plus(query))
		#print url
		req=urllib2.Request(url)
		req.add_header("User-Agent","Opera/9.50 (J2ME/MIDP; Opera Mini/4.1.11355/546; U; en)")
		if self.proxy:
			opener = urllib2.build_opener(urllib2.ProxyHandler(self.proxy))
			urllib2.install_opener(opener)
		else:
			opener = urllib2.build_opener()
		try:
			html=opener.open(req).read()
		except:
			return (None,True)
		urls=re.findall("<div class=\"padbottom\"> <a href=\"(.*?)\"",html)#[:5]
		if urls == None:
			return (None,False)
		for i in range(len(urls)):
			urls[i]=decode_htmlentities(urls[i])
			if urls[i].startswith("/m/url?") or urls[i].startswith("/gwt/n?"):
				try:
					urls[i]=urllib.unquote_plus(re.findall("(http%3A%2F%2F.*?)&",urls[i])[0])
				except IndexError:
					sys.stderr.write(urls[i])
					raise IndexError
		l=[]
		for url in urls:
			for key in urlcheck:
				if urlcheck[key].search(url):
					l.append((url,sites[key]))
					break		
		if l:
			return (l,False)
		return (None,False)

	def getLyrics(self,url,regex):
		req=urllib2.Request(url)
		req.add_header("User-Agent","Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)")
		cj = cookielib.LWPCookieJar()
		if self.proxy:
			opener = urllib2.build_opener(urllib2.ProxyHandler(self.proxy),urllib2.HTTPCookieProcessor(cj))
		else:
			opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
		#print url
		try:
			ff=opener.open(req)
		except:
			#print "timeout"
			return (None,True)
		html = ff.read()
		#print html
		result = regex.search(html)
		if result == None:
			#print "not found in text, try to update the regex for this site: %s" % url
			#print html
			return (None,False)
			#sys.stderr.write("Error: Lyrics not found on site %s\n" % url)
			#raise AttributeError
		data=result.group(1)

		brs = re.findall(r'<br',data,re.IGNORECASE)
		if len(brs) > 3: #lyrics in <pre> tags doesn't use <br /> tags
			data = re.compile(r'[\r\n]+').sub("", data)
		del brs
		data = re.compile(r'<[bB][rR][ /]*>').sub("\n", data)
		data = data.replace('\x92','&apos;')
		data = re.compile(r'<script.*?</script>').sub("",data)
		data = re.compile(r'<.*?>').sub("", data)
		data = re.compile(r'Please enable javascript to see this content.').sub("", data)
		data = data.strip()
		try:
			data = decode_htmlentities(data)
		except:
			try:
				data = decode_htmlentities(data.decode('iso-8859-1'))
			except:
				try:
					data = decode_htmlentities(data.decode('utf-8'))
				except:
					try:
						data = decode_htmlentities(data.decode('utf-16'))
					except:
						data = decode_htmlentities(data.decode('gb18030'))
		#print url
		return (data,False)

