#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: helpBrowser.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

from PyQt4.QtCore import *
from PyQt4.QtGui import *
import sys

class helpWindow(QDialog):
	
	def __init__(self,*args):
        	apply(QDialog.__init__,(self,) + args)
		self.setWindowTitle(_('Document reader'))
		self.setWindowIcon(QIcon('./icon/help.png'))
		self.label=QLabel(self)
		self.label.setText(_('Please choose :'))
		self.contentBro=browserView(self)
		self.itemBro=itemListView(self)
		MainWindowLayout=QVBoxLayout(self)
		layout1=QHBoxLayout(None)
		layout1.addWidget(self.label)
		layout1.addWidget(self.itemBro)
		layout2=QVBoxLayout(None,)
		layout2.addLayout(layout1)
		layout2.addWidget(self.contentBro)
		MainWindowLayout.addLayout(layout2)
		self.setMinimumSize(500,300)
		self.connect(self.itemBro,SIGNAL("activated(int)"),self.moveTo)
		
	def moveTo(self,f):
		self.contentBro.clear()
		if(f==0):
			fileName='./README'
		elif(f==1):
			fileName='./document/document-zh.html'
		elif(f==2):
			fileName='./document/document-en.html'
		elif(f==3):
			fileName='./COPYING'
		file=open(fileName)
		a=file.read()
		file.close()
			
		if(f==3):
			self.contentBro.setPlainText(a.decode('utf8'))
		else:
			self.contentBro.setHtml(a.decode('utf8'))

class itemListView(QComboBox):
	
	def __init__(self,*args):
        	apply(QComboBox.__init__,(self,) + args)
		a=['README',_('Help document - Chinese'),_('Help document - English'),_('License')]
		for i in range(len(a)):
			self.insertItem(i,a[i])
		

class browserView(QTextBrowser):
	
	def __init__(self,*args):
        	apply(QTextBrowser.__init__,(self,) + args)
		self.setWordWrapMode(QTextOption.WordWrap)
		self.setHorizontalScrollBarPolicy(Qt.ScrollBarAlwaysOff)
		file=open('./README')
		a=file.read()
		file.close()
		self.setHtml(a.decode('utf8')) 
