#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: lrcShow-X.py
# Develop CodeName: Shiningirl
# Version:  1.0.0
# Author: Xu Jia (sanfanling) and OutLikeAShoe
# Lisence: GPL-2.0
# Bug report: xujia19@gmail.com

#lrcShow-X: lrc script for Amarok at present
#Copyright (C) 2008 Xu Jia <xujia19@gmail.com>

#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import os,sys,gettext,pickle,ConfigParser,commands
#from dbus.mainloop.glib import threads_init as dthreads_init
#from gobject import threads_init as gthreads_init


def initConfigFile():
	c='''[option]
lrcpath = %s,
savelrcpath = %s
download = no
linenumber = 3
backroundcolor = 59,86,115
fontcolor = 255,255,255
highlightcolor = 180,200,255
fontinfo = serif,9,-1,5,50,0,0,0,0,0
proxy = no
encoder = utf8
searchengine = ttPlayer
nolrc = normal
includecancel = no
autoinsert = no
titlebarinfo = no
completetag = no
filterlyrics = no
nullline = no
filterrule = http|lyrics|qq
filtercap = no
astrackname = no
minwidth = 360
horizontal = no
savetomediapath = no
searchmediapath = no
useuslt = no
lastposition = 0,0
lrctagtype = lyrics3v2
lastshowmode = normal
lastistop = no
remembershowmode = no
trayicon = no
trayiconnotify = no
transparency = no
opacity = 10
rememberopacity = no
trayinfotime = 5000

[shortcuts]
fullscreen = F
osd = O
normal = Esc
insert = F5
cancel = F6
editor = E
save = S
delay = -
advance = +
fastbar = I
refresh = R

[version]
pyqt = 4''' %(os.getenv('HOME'),os.getenv('HOME'))
	return c

def mainQt4(args):

	app=QApplication(sys.argv)
	win=mainBox(args)
	win.show()
	sys.exit(app.exec_())

if(__name__=="__main__"):
		
	supportedPlayer=['audacious','amarok','vlc','exaile','quodlibet','qmmp']
	if(len(sys.argv)==1 or len(sys.argv)>2):
		print 'Usage: lrcShow-X [--help] [--audacious] [--amarok] [--vlc] [--exaile] [--quodlibet] [--qmmp]'
		sys.exit()
	else:
		if(sys.argv[1]=='--help' or sys.argv[1][:2]<>'--'):
			print 'Usage: lrcShow-X [--help] [--audacious] [--amarok] [--vlc] [--exaile] [--quodlibet] [--qmmp]'
			sys.exit()
		else:
			argv=sys.argv[1].replace('-','')
			if(argv not in supportedPlayer):
				print 'Error: %s is not supported at present' %argv.title()
				sys.exit()

	try:
		gettext.translation('lrcShow-X','locale').install(unicode=True)
	except IOError:
		gettext.translation('lrcShow-X','locale',languages=['en_US']).install(unicode=True)
	
	homePath=os.getenv('HOME')
	
	if(not os.path.isdir('%s/.lrcShow-X' %homePath)):
		os.mkdir('%s/.lrcShow-X' %homePath)
	
	if(not os.path.exists('%s/.lrcShow-X/lrcShow-X.db' %homePath)):
		mydb=open('%s/.lrcShow-X/lrcShow-X.db' %homePath,'w')
		pickler=pickle.Pickler(mydb,True)
		pickler.dump({})
		mydb.close()
	
	if(not os.path.exists('%s/.lrcShow-X/lrcShow-X.conf' %homePath)):
		try:
			from PyQt4.QtCore import *
			from PyQt4.QtGui import *
		except ImportError:
			#os.system('dcop amarok playlist popupMessage "lrcShow-X: you should install pyqt3 or pyqt4 in your system first"')
			sys.exit()
		else:
			config=initConfigFile()
			file=open('%s/.lrcShow-X/lrcShow-X.conf' %homePath,'w')
			file.write(config)
			file.close()

	from PyQt4.QtCore import *
	from PyQt4.QtGui import *
	from mainGuiQt4 import *
	
	#gthreads_init()
	#dthreads_init()


	mainQt4(argv)

