#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: audacious.py

import dbus
from playerBase import playerBase

class mprisPlayer(playerBase):
	
	def __init__(self,player):
		playerBase.__init__(self,player)
		bus=dbus.SessionBus()
		proxy_obj=bus.get_object(self.obj1,self.obj2)
		self.iface=dbus.Interface(proxy_obj, self.obj3)
	
	def getTitle(self):
		return self.iface.GetMetadata()['title']
	
	def getArtist(self):
		return self.iface.GetMetadata()['artist']
	
	def getTimePoint(self):
		return self.iface.PositionGet()
	
	def getMediaFile(self):
		return self.iface.GetMetadata()['URI']
	
	def getStatus(self):
		return self.iface.GetStatus()[0]
		
	def playFunc(self):
		self.iface.Play()
	
	def pauseFunc(self):
		self.iface.Pause()
	
	def stopFunc(self):
		self.iface.Stop()
	
	def prevFunc(self):
		self.iface.Prev()
	
	def nextFunc(self):
		self.iface.Next()  
