#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename:  exaile.py

import dbus
from playerBase import playerBase

class mprisPlayer(playerBase):
	
	def __init__(self,player):
		playerBase.__init__(self,player)
		bus=dbus.SessionBus()
		proxy_obj=bus.get_object(self.obj1,self.obj2)
		self.iface=dbus.Interface(proxy_obj, self.obj3)
	
	def getTitle(self):
		return self.iface.get_title()
	
	def getArtist(self):
		return self.iface.get_artist()
	
	def getTimePoint(self):
		total=self.iface.get_length()
		minutes,seconds=map(lambda x: int(x),total.split(':'))
		sec=minutes*60+seconds
		return sec*int(self.iface.current_position())*10
	
	def getMediaFile(self):
		return self.iface.get_track_attr('loc')
	
	def getStatus(self):
		if(self.iface.status()=='playing'):
			return 0
		elif(self.iface.status()=='stoped'):
			return 2
		elif(self.iface.status()=='paused'):
			return 1
		
	def playFunc(self):
		self.iface.play_pause()
	
	def pauseFunc(self):
		self.iface.play_pause()
	
	def stopFunc(self):
		self.iface.stop()
	
	def prevFunc(self):
		self.iface.prev_track()
	
	def nextFunc(self):
		self.iface.next_track()