#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename:  qmmp.py

import dbus
from playerBase import playerBase

class mprisPlayer(playerBase):
	
	def __init__(self,player):
		playerBase.__init__(self,player)
		bus=dbus.SessionBus()
		proxy_obj=bus.get_object(self.obj1,self.obj2)
		self.iface=dbus.Interface(proxy_obj, self.obj3)
		self.ifaceProperties=dbus.Interface(proxy_obj, 'org.freedesktop.DBus.Properties')
	
	def getTitle(self):
		return self.ifaceProperties.Get('org.qmmp.dbus','title')
	
	def getArtist(self):
		return self.ifaceProperties.Get('org.qmmp.dbus','artist')
	
	def getTimePoint(self):
		return int(self.ifaceProperties.Get('org.qmmp.dbus','elapsedTime'))*1000
	
	def getMediaFile(self):
		return self.ifaceProperties.Get('org.qmmp.dbus','path')
	
	def getStatus(self):
		if(bool(self.ifaceProperties.Get('org.qmmp.dbus','isPaused'))):
			return 1
		elif(bool(self.ifaceProperties.Get('org.qmmp.dbus','isStopped'))):
			return 0
		else:
			return 2
		
	def playFunc(self):
		self.iface.play()
	
	def pauseFunc(self):
		self.iface.pause()
	
	def stopFunc(self):
		self.iface.stop()
	
	def prevFunc(self):
		self.iface.previous()
	
	def nextFunc(self):
		self.iface.next() 
