#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename:  quodlibet.py

import dbus
from playerBase import playerBase

class mprisPlayer(playerBase):
	
	def __init__(self,player):
		playerBase.__init__(self,player)
		bus=dbus.SessionBus()
		proxy_obj=bus.get_object(self.obj1,self.obj2)
		self.iface=dbus.Interface(proxy_obj, self.obj3)
	
	def getTitle(self):
		try:
			t=self.iface.CurrentSong()['title']
		except:
			return ''
		else:
			return t
	
	def getArtist(self):
		try:
			a=self.iface.CurrentSong()['artist']
		except:
			return ''
		else:
			return a
	
	def getTimePoint(self):
		return self.iface.GetPosition()
	
	def getMediaFile(self):
		return 'sdfsdf'
	
	def getStatus(self):
		if(bool(self.iface.IsPlaying())):
			return 0
		else:
			return 1
		
	def playFunc(self):
		self.iface.PlayPause()
	
	def pauseFunc(self):
		self.iface.PlayPause()
	
	def stopFunc(self):
		self.iface.Pause()
	
	def prevFunc(self):
		self.iface.Previous()
	
	def nextFunc(self):
		self.iface.Next()