#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: otherSettingQt4.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

from PyQt4.QtGui import *
from PyQt4.QtCore import *
import sys,os

class otherSettingQt4(QDialog):
	
	def __init__(self,*args):
        	apply(QDialog.__init__,(self,) + args)
		self.setWindowTitle(_('Configure'))
		
		mainWindowLayout=QVBoxLayout(None)
		
		layout1=QHBoxLayout(None)
		self.settingPage=QStackedWidget(self)
		self.normalPage=normalPage(self)
		self.settingPage.addWidget(self.normalPage)
		self.behaviorPage=behaviorPage(self)
		self.settingPage.addWidget(self.behaviorPage)
		self.lrcPathPage=lrcPathPage(self)
		self.settingPage.addWidget(self.lrcPathPage)
		self.limitPage=limitPage(self)
		self.settingPage.addWidget(self.limitPage)
		self.shortcutPage=shortcutPage(self)
		self.settingPage.addWidget(self.shortcutPage)
		self.trayPage=trayPage(self)
		self.settingPage.addWidget(self.trayPage)

		self.itemBox=QListWidget(self)
		self.itemBox.setFixedWidth(100)
		itemList=[_('General'),_('Window'),_('Path'),_('Filter'),_('Shortcuts'),_('Tray icon')]
		for i in itemList:
			self.itemBox.addItem(i)
		layout1.addWidget(self.itemBox)
		layout1.addWidget(self.settingPage)
		
		layout2=QHBoxLayout(None)
		layout2.addStretch(0)
		layout2.SizeConstraint(QLayout.SetFixedSize)
		layout2.setSpacing(20)
		layout2.setContentsMargins(230,10,10,10)
		self.okButtong=QPushButton(_('Ok'),self)
		self.cancelButton=QPushButton(_('Cancel'),self)
		layout2.addWidget(self.okButtong)
		layout2.addWidget(self.cancelButton)
		
		mainWindowLayout.addLayout(layout1)
		mainWindowLayout.addLayout(layout2)
		self.setLayout(mainWindowLayout)
		
		self.connect(self.okButtong,SIGNAL("clicked()"),self,SLOT("accept()"))
		self.connect(self.cancelButton,SIGNAL("clicked()"),self,SLOT("reject()"))
		self.connect(self.itemBox,SIGNAL("currentRowChanged(int)"),self.settingPage,SLOT("setCurrentIndex(int)"))
		

###############   page: 1    ############

class normalPage(QWidget):
	
	def __init__(self,*args):
		apply(QWidget.__init__,(self,) + args)

		mainLayout=QVBoxLayout(None)
		mainLayout.setContentsMargins(0,0,0,80)
		
		#self.autoInsert=QCheckBox('Auto send lrc to Amarok sidebar',self)
		self.completeTagSearch=QCheckBox(_('Search lrc only when has full tag information'),self)
		self.asTrackName=QCheckBox(_('Search local and name lrc file as media file\'s name'),self)
		self.lrcInMedia=QCheckBox(_('Prioritize the lrc in media file'),self)
		
		layout3=QHBoxLayout(None)
		layout3.setContentsMargins(0,20,100,0)
		self.embedLable=QLabel(_('Tag type of embedding lyrics to operation :'),self)
		self.comboBoxType=QComboBox(self)
		self.strTagList=['id3v2-uslt','apetag','lyrics3v2','lyrics3v1','id3v2-sylt']
		tagTypeList=QStringList()
		for i in self.strTagList:
			tagTypeList.append(i)
		self.comboBoxType.addItems(tagTypeList)
		layout3.addWidget(self.embedLable)
		layout3.addWidget(self.comboBoxType)
		
		
		layout1=QHBoxLayout(None)
		layout1.setContentsMargins(0,20,100,0)
		self.saveEncoderLabel=QLabel(_('Set encoding for saving :'),self)
		self.comboBox=QComboBox(self)
		self.strList=['latin1','big5','big5-hkscs','eucjp','shift-jis','iso 2022-jp-1','euc-jisx0213','euckr','gb2312','gbk','gb18030','utf8','utf16','koi8-r','koi8-u','iso 8859-1','iso 8859-2','iso 8859-3','iso 8859-4','iso 8859-5','iso 8859-6','iso 8859-7','iso 8859-8','iso 8859-9','iso 8859-10','iso 8859-13','iso 8859-14','iso 8859-15','ibm850','ibm866','cp874','cp1250','cp1251','cp1252','cp1253','cp1254','cp1255','cp1256','cp1257','cp1258','tis-620','mac roman']
		codecList=QStringList()
		for i in self.strList:
			codecList.append(i)
		self.comboBox.addItems(codecList)
		layout1.addWidget(self.saveEncoderLabel)
		layout1.addWidget(self.comboBox)
		
		layout2=QHBoxLayout(None)
		layout2.setContentsMargins(0,20,0,0)
		self.proxyLabel=QLabel(_('Set proxy :'),self)
		self.proxy=QLineEdit(self)
		layout2.addWidget(self.proxyLabel)
		layout2.addWidget(self.proxy)
		self.commentLabel=QLabel(_('(Leave it empty if no proxy, the foramt is: http://xxx.yyy.xxx:ww)'),self)
		
		mainLayout.addWidget(self.completeTagSearch)
		#mainLayout.addWidget(self.autoInsert)
		mainLayout.addWidget(self.asTrackName)
		mainLayout.addWidget(self.lrcInMedia)
		mainLayout.addLayout(layout3)
		mainLayout.addLayout(layout1)
		mainLayout.addLayout(layout2)
		mainLayout.addWidget(self.commentLabel)
		
		self.setLayout(mainLayout)
		
		#self.connect(self.autoInsert,SIGNAL("clicked(bool)"),self.autoInsertWarning)
	
	#def autoInsertWarning(self,checked):
		#if(checked):
		#QMessageBox.warning(self,'Notice',Strongly recommend to stop other Amarok lyrics script, if choose this option')

################### page:  2   ##################

class behaviorPage(QWidget):
	
	def __init__(self,*args):
		apply(QWidget.__init__,(self,) + args)
		mainLayout=QVBoxLayout(None)
		mainLayout.setContentsMargins(0,0,0,50)
		
		self.autoTitleBar=QCheckBox(_('Show tag information in title bar'),self)
		self.rememberLastShowMode=QCheckBox(_('Launched with last show-mode settings'),self)
		self.switchHorizontal=QCheckBox(_('Switch to horizontal show when show-line is 1 (need to restart)'),self)
		self.enableTransparency=QCheckBox(_('Change transparency by wheel'),self)
		self.rememberOpacity=QCheckBox(_('Remember the transparency when quit'),self)
		self.rememberOpacity.setEnabled(False)
		
		layout1=QHBoxLayout(None)
		layout1.setContentsMargins(0,0,200,0)
		self.minLabel=QLabel(_('Minimum width :'),self)
		self.minWidth=QSpinBox(self)
		self.minWidth.setMaximum(QApplication.desktop().width())
		self.minWidth.setMinimum(100)
		layout1.addWidget(self.minLabel)
		layout1.addWidget(self.minWidth)
		
		self.groupHide=groupHide(_('When no lrc, the window :'),self)

		mainLayout.addWidget(self.autoTitleBar)
		mainLayout.addWidget(self.rememberLastShowMode)
		mainLayout.addWidget(self.enableTransparency)
		mainLayout.addWidget(self.rememberOpacity)
		mainLayout.addWidget(self.switchHorizontal)
		mainLayout.addLayout(layout1)
		mainLayout.addWidget(self.groupHide)
		
		self.setLayout(mainLayout)
	
		self.connect(self.groupHide.normal,SIGNAL("toggled(bool)"),self.normalChecked)
		self.connect(self.enableTransparency,SIGNAL("clicked(bool)"),self.enableWarn)
		self.connect(self.enableTransparency,SIGNAL("toggled(bool)"),self.rememberOpacity,SLOT("setEnabled(bool)"))
	
	def enableWarn(self,t):
		if(t):
			QMessageBox.information(self,_('Notice'),_('Please confirm the WM supporting this function, otherwise it won\'t work!'))
	
	def normalChecked(self,checked):
		if(checked):
			self.groupHide.includeCheckBox.setEnabled(False)
		else:
			self.groupHide.includeCheckBox.setEnabled(True)

class groupHide(QGroupBox):
	
	def __init__(self,*args):
        	apply(QGroupBox.__init__,(self,) + args)
		mainLayout=QVBoxLayout(None)
		
		self.normal=QRadioButton(_('No behavior'),self)
		self.hide=QRadioButton(_('Auto hide'),self)
		self.mini=QRadioButton(_('Auto minimized'),self)
		self.includeCheckBox=QCheckBox(self)
		self.includeCheckBox.setText(_('Including cancellation the lrc'))
		
		mainLayout.addWidget(self.normal)
		mainLayout.addWidget(self.hide)
		mainLayout.addWidget(self.mini)
		mainLayout.addWidget(self.includeCheckBox)
		self.setLayout(mainLayout)

#################Page:  3   ########################

class lrcPathPage(QWidget):
	
	def __init__(self,*args):
		apply(QWidget.__init__,(self,) + args)
		
		layout5=QVBoxLayout(None)
		
		layout2=QHBoxLayout(None)
		self.table=QTableWidget(0,1,self)
		self.table.setEditTriggers(QAbstractItemView.NoEditTriggers)
        	self.table.setSelectionBehavior(QAbstractItemView.SelectRows)
		self.table.setSelectionMode(QAbstractItemView.SingleSelection)
		self.table.setMinimumWidth(260)
		title=QStringList()<<_('Search path')
		self.table.setHorizontalHeaderLabels(title)
		self.table.setColumnWidth(0,240)
		self.rowNumber=0
		
		layout1=QVBoxLayout(None)
		self.add=QPushButton(_('Add...'),self)
		self.remove=QPushButton(_('Remove'),self)
		self.remove.setEnabled(False)
		self.up=QPushButton(_('Up'),self)
		self.up.setEnabled(False)
		self.down=QPushButton(_('Down'),self)
		self.down.setEnabled(False)
		layout1.addWidget(self.add)
		layout1.addWidget(self.remove)
		layout1.addWidget(self.up)
		layout1.addWidget(self.down)
		
		layout2.addWidget(self.table)
		layout2.addLayout(layout1)
		
		layout4=QHBoxLayout(None)
		layout4.setContentsMargins(0,15,0,15)
		self.savePath=QLineEdit(self)
		self.savePath.setReadOnly(True)
		self.addSavePath=QPushButton(self)
		self.addSavePath.setText(_('Save path...'))
		layout4.addWidget(self.savePath)
		layout4.addWidget(self.addSavePath)
		
		self.saveToMediaPath=QCheckBox(_('Save the lrc file in track\'s path'),self)
		self.searchMediaPath=QCheckBox(_('Search the lrc file in track\'s path additionally'),self)
		
		layout5.addLayout(layout2)
		layout5.addLayout(layout4)
		layout5.addWidget(self.saveToMediaPath)
		layout5.addWidget(self.searchMediaPath)

		
		self.setLayout(layout5)
		
		self.connect(self.saveToMediaPath,SIGNAL("clicked(bool)"),self.cautionAction)
		self.connect(self.add,SIGNAL("clicked()"),self.addPath)
		self.connect(self.remove,SIGNAL("clicked()"),self.removePath)
		self.connect(self.up,SIGNAL("clicked()"),self.upAction)
		self.connect(self.down,SIGNAL("clicked()"),self.downAction)
		self.connect(self.table,SIGNAL("cellClicked(int,int)"),self.enableButton)
		self.connect(self.addSavePath,SIGNAL("clicked()"),self.addSavePathAction)
	
	def cautionAction(self,bool):
		if(bool):
			self.addSavePath.setEnabled(False)
			self.savePath.setEnabled(False)
			QMessageBox.information(self,_('Notice'),_('It is not recommended :\n1.It would cause some players updating the collection\n2.The path may not have writing permission, and cause downloading fail'))
		else:
			self.addSavePath.setEnabled(True)
			self.savePath.setEnabled(True)
	
	def addPath(self):
		path=QFileDialog.getExistingDirectory(self,_('Please choose search lrc path'),os.getenv("HOME"))
		if(path<>u''):
			flag=False
			for i in range(0,self.rowNumber):
				if(self.table.item(i,0).text()==path):
					flag=True
			if(flag==False):
				self.insertItem(QTableWidgetItem(path,0))
				self.updownButton(self.table.currentRow())
			else:
				QMessageBox.information(self,_('Notice'),_('This path already has been added'))
	
	def insertItem(self,item):
		self.rowNumber+=1
		self.table.setRowCount(self.rowNumber)
		self.table.setItem(self.rowNumber-1,0,item)
	
	def removePath(self):
		self.table.removeRow(self.table.currentRow())
		self.rowNumber-=1
		self.updownButton(self.table.currentRow())
	
	def enableButton(self,row,column):
		self.remove.setEnabled(True)
		self.updownButton(row)
	
	def upAction(self):
		row=self.table.currentRow()
		item_column0=self.table.takeItem(row,0)
		tmp_row=row-1
		tmp_column0=self.table.takeItem(tmp_row,0)
		self.table.setItem(row,0,tmp_column0)
		self.table.setItem(tmp_row,0,item_column0)
		self.table.selectRow(tmp_row)
		self.updownButton(tmp_row)
	
	def downAction(self):
		row=self.table.currentRow()
		item_column0=self.table.takeItem(row,0)
		tmp_row=row+1
		tmp_column0=self.table.takeItem(tmp_row,0)
		self.table.setItem(row,0,tmp_column0)
		self.table.setItem(tmp_row,0,item_column0)
		self.table.selectRow(tmp_row)
		self.updownButton(tmp_row)
	
	def addSavePathAction(self):
		path=QFileDialog.getExistingDirectory(self,_('Please choose a path for saving lrc'),os.getenv("HOME"))
		if(path<>u''):
			if(os.access(str(path.toLocal8Bit()),os.W_OK)):
				self.savePath.setText(path)
			else:
				QMessageBox.information(self,_('Notice'),_('It does not have writing permission'))
		
	def updownButton(self,row):
		if(row==0):
			self.up.setEnabled(False)
		else:
			self.up.setEnabled(True)
		if(row==self.rowNumber-1):
			self.down.setEnabled(False)
		else:
			self.down.setEnabled(True)
		if(row<0):
			self.up.setEnabled(False)
			self.down.setEnabled(False)
			self.remove.setEnabled(False)

#################Page:  4   ########################

class limitPage(QWidget):
	
	def __init__(self,*args):
		apply(QWidget.__init__,(self,) + args)
		mainLayout=QVBoxLayout(None)
		mainLayout.setContentsMargins(0,0,0,200)
		self.filterCheckBox=QCheckBox(_('Filter function'),self)
		self.filterCheckBox.setChecked(True)
		self.nullLine=QCheckBox(_('Show an empty line when the line is filtered'),self)
		self.filterCap=QCheckBox(_('Ignore letters\' upper and lower case'),self)
		self.comment=QLabel(_('(Filter keywords are separated by \"|\"; supporting regular expression)'),self)
		self.filterKeyWold=QLineEdit(self)
		mainLayout.addWidget(self.filterCheckBox)
		mainLayout.addWidget(self.nullLine)
		mainLayout.addWidget(self.filterCap)
		mainLayout.addWidget(self.comment)
		mainLayout.addWidget(self.filterKeyWold)
		self.setLayout(mainLayout)
		
		self.connect(self.filterCheckBox,SIGNAL("toggled(bool)"),self.filterChecked)

	def filterChecked(self,checked):
		if(checked):
			self.nullLine.setEnabled(True)
			self.comment.setEnabled(True)
			self.filterKeyWold.setEnabled(True)
			self.filterCap.setEnabled(True)
		else:
			self.nullLine.setEnabled(False)
			self.comment.setEnabled(False)
			self.filterKeyWold.setEnabled(False)
			self.filterCap.setEnabled(False)

#################Page:  5   ########################

class shortcutPage(QWidget):
	
	def __init__(self,*args):
		apply(QWidget.__init__,(self,) + args)
		
		mainLayout=QVBoxLayout(None)
		
		layout1=QHBoxLayout(None)
		self.setShortcut=QPushButton(_('Set shortcut...'),self)
		self.setShortcut.setEnabled(False)
		self.setDefault=QPushButton(_('Back to default'),self)
		layout1.addWidget(self.setShortcut)
		layout1.addWidget(self.setDefault)
		
		shortcutDescribe=[_('Fullscreen mode'),_('OSD mode'),_('Normal mode'),_('Lrceditor : Insert time-tag'),_('Lrceditor : Undo'),_('Lrc editor'),_('Save offset'),_('Delay the lrc 0.2sec'),_('Advance the lrc 0.2sec'),_('Fast setting bar'),_('Reload lrc')]
		
		import readConfig
		#p=readConfig.readConfig('../../scripts-data/lrcShow-II.conf')
		p=readConfig.readConfig()
		self.shortcutValue=p.parseShortcut()
		
		self.itemNum=len(shortcutDescribe)
		self.table=QTableWidget(self.itemNum,2,self)
		self.table.setEditTriggers(QAbstractItemView.NoEditTriggers)
        	self.table.setSelectionBehavior(QAbstractItemView.SelectRows)
		self.table.setSelectionMode(QAbstractItemView.SingleSelection)
		self.table.setColumnWidth(0,220)
		self.table.setColumnWidth(1,80)
		title=QStringList()<<_('Description')<<_('Shortcuts')
		self.table.setHorizontalHeaderLabels(title)
		for i in range(self.itemNum):
			self.table.setItem(i,0,QTableWidgetItem(shortcutDescribe[i],0))
			self.table.setItem(i,1,QTableWidgetItem(self.shortcutValue[i],0))
		
		mainLayout.addWidget(self.table)
		mainLayout.addLayout(layout1)
		self.setLayout(mainLayout)
		
		self.connect(self.table,SIGNAL("cellClicked(int,int)"),self.activeSet)
		self.connect(self.setShortcut,SIGNAL("clicked()"),self.changeShortcut)
		self.connect(self.table,SIGNAL("cellDoubleClicked(int,int)"),self.changeShortcut)
		self.connect(self.setDefault,SIGNAL("clicked()"),self.defaultAction)
		
	def defaultAction(self):
		self.shortcutValue=['F','O','Esc','F5','F6','E','S','-','+','I','R']
		for i in range(self.itemNum):
			self.table.setItem(i,1,QTableWidgetItem(self.shortcutValue[i],0))
	
	def activeSet(self,row,col):
		if(not self.setShortcut.isEnabled()):
			self.setShortcut.setEnabled(True)
	
	def changeShortcut(self):
		row=self.table.currentRow()
		editorBox=shortcutBox()
		editorBox.editorBox.setText(self.table.item(row,1).text())
		result=editorBox.exec_()
		if(result==QDialog.Accepted):
			tmpList=[]
			for i in range(self.itemNum):
				if(i==row):
					pass
				else:
					tmpList.append(self.table.item(i,1).text())
			if(editorBox.editorBox.text() in tmpList):
				QMessageBox.information(self,_('Shortcuts conflict'),_('The operation was canceled'))
			else:
				self.table.setItem(row,1,QTableWidgetItem(editorBox.editorBox.text(),0))
				for i in range(self.itemNum):
					self.shortcutValue[i]=str(self.table.item(i,1).text())


class shortcutBox(QDialog):
	
	def __init__(self,*args):
		apply(QDialog.__init__,(self,) + args)
		self.setWindowTitle(_('Capturing Shortcut'))
		mainLayout=QVBoxLayout(None)
		layout1=QHBoxLayout(None)
		self.ok=QPushButton(_('Ok'),self)
		self.cancel=QPushButton(_('Cancel'),self)
		self.clear=QPushButton(_('Clear'),self)
		layout1.addWidget(self.ok)
		layout1.addWidget(self.clear)
		layout1.addWidget(self.cancel)
		self.comment=QLabel(_('Single Key allowed'),self)
		self.editorBox=QLineEdit(self)
		self.editorBox.setReadOnly(True)
		self.editorBox.setFocus()
		mainLayout.addWidget(self.comment)
		mainLayout.addWidget(self.editorBox)
		mainLayout.addLayout(layout1)
		self.setLayout(mainLayout)
		
		self.connect(self.ok,SIGNAL("clicked()"),self,SLOT("accept()"))
		self.connect(self.cancel,SIGNAL("clicked()"),self,SLOT("reject()"))
		self.connect(self.clear,SIGNAL("clicked()"),self.editorBox,SLOT("clear()"))
	
	def keyPressEvent(self,ev):
		self.editorBox.setText(QKeySequence(ev.key()).toString())
	
#################Page:  6   ########################

class trayPage(QWidget):
	
	def __init__(self,*args):
		apply(QWidget.__init__,(self,) + args)
		
		mainLayout=QVBoxLayout(None)
		mainLayout.setContentsMargins(0,0,0,230)
		self.enableTray=QCheckBox(_('Enable the tray icon'),self)
		self.enableNotify=QCheckBox(_('Enable the notify from tray icon'),self)
		layout1=QHBoxLayout(None)
		layout1.setContentsMargins(10,0,200,0)
		self.trayTimeLabel=QLabel(_('Tray info lasts (seconds) :'))
		self.trayTime=QSpinBox(self)
		self.trayTime.setMaximum(15)
		self.trayTime.setMinimum(1)
		layout1.addWidget(self.trayTimeLabel)
		layout1.addWidget(self.trayTime)
		mainLayout.addWidget(self.enableTray)
		mainLayout.addWidget(self.enableNotify)
		mainLayout.addLayout(layout1)
		self.setLayout(mainLayout)
		
		self.connect(self.enableTray,SIGNAL("toggled(bool)"),self.enableNotify,SLOT("setEnabled(bool)"))
		self.connect(self.enableTray,SIGNAL("toggled(bool)"),self.trayTime,SLOT("setEnabled(bool)"))

def main(args):
	app=QApplication(args)
	win=otherSettingQt4()
	win.show()
	sys.exit(app.exec_())

#def _(x):
	#return x

if(__name__=="__main__"):
	main(sys.argv)